"""
执行时需要继承Testunner这个类
不允许重载__init__函数
"""
from base.case_runner import TestRunner
from base.case_runner import py_driver
from base import loginfo
from data.template_casedata import *
from base.setting import setting

def read_data(path):
    with open(path, 'r', encoding='utf-8') as fp:
        return fp.read().split('\n')

def write_data(path, data):
    with open(path, 'w', encoding='utf-8') as fp:
        fp.write(data)

@py_driver(api_case=API, scene_case=SCENE)
class GQTest(TestRunner):

    def before_parameter(self, case, mid_res):

        if case.name == 'make_kuwei':
            self.create_3dlocation_test(case, mid_res)


    # 创建3D库位测试用
    def create_3dlocation_test(self,case, mid_res):
        info = read_data('./data.txt')
        # 代码--参考代码，名称保持一致
        code = 'A1-A5-2-105'
        x = '1200'
        y = '8400'
        z = '1000'
        # 库区信息
        # zone__code = '8000'
        # zone__name = '原料库区'
        # parent2 = '292945353773289472'
        case.request_data['selectedRows'][0]['header']['currentData']['code'] = code
        case.request_data['selectedRows'][0]['header']['currentData']['name'] = code
        case.request_data['selectedRows'][0]['header']['currentData']['refer_code'] = code
        case.request_data['selectedRows'][0]['header']['currentData']['x_coordinate'] = x
        case.request_data['selectedRows'][0]['header']['currentData']['y_coordinate'] = y
        case.request_data['selectedRows'][0]['header']['currentData']['z_coordinate'] = z
        # case.request_data['selectedRows'][0]['header']['currentData']['zone__code'] = zone__code
        # case.request_data['selectedRows'][0]['header']['currentData']['zone__name'] = zone__name
        # case.request_data['selectedRows'][0]['header']['currentData']['parent2'] = parent2
        mid_res['data_test'] = [code, x, y, z]

    def after_parameter(self, case, mid_res):
        print('678987656789')
        for i in range(1, 9):
            mid_res['data_test'][0] = 'A1-A4-2-10{}'.format(i)
            mid_res['data_test'][1] = str(i*1200)
            # mid_res['data_test'][2] = ''
            # mid_res['data_test'][3] = ''
            yield mid_res


        loginfo.debug('\033[32m用例执行后数据处理 {}\033[0m'.format(case.actual))


if __name__ == '__main__':
    GQTest().run_test()
    # a = read_data('./data.txt')
    # print(a)