"""
执行时需要继承Testunner这个类
不允许重载__init__函数
"""
from base.case_runner import TestRunner
from base.case_runner import py_driver
from base import loginfo
from data.template_casedata import *
from base.setting import setting


@py_driver(api_case=API, scene_case=SCENE)
class GQTest(TestRunner):

    # 重写用例执行前的方法
    def before_parameter(self, case, mid_res):
        """
            case--用例对象，可以通过case.name,或者request_data等这里的属性与excel中的属性保持一致
        """

        name = setting.warehouse_rule['warehouse_name']
        code = setting.warehouse_rule['warehouse_code']
        if case.name == 'batch_rule':
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__name'] = name
            case.request_data['selectedRows'][0]['header']['currentData']['code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['name'] = name + '批次规则'
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse_id'] = mid_res['id']

        elif case.name == 'mixing_rule':
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__name'] = name
            case.request_data['selectedRows'][0]['header']['currentData']['code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['name'] = name + '波段规则'
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse_id'] = mid_res['id']

        elif case.name == 'receiving_verification_rule':
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__name'] = name
            case.request_data['selectedRows'][0]['header']['currentData']['code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['name'] = name + '发货验证规则'
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse_id'] = mid_res['id']

        elif case.name == 'turnover_rule':
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__name'] = name
            case.request_data['selectedRows'][0]['header']['currentData']['code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['name'] = name + '周转规则'
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse_id'] = mid_res['id']

        elif case.name == 'listing_rule':
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__name'] = name
            case.request_data['selectedRows'][0]['header']['currentData']['code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['name'] = name + '上架规则'
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse_id'] = mid_res['id']

        # elif case.name == 'listing_rule_s':
        #     case.request_data['data']['header']['id'] = name
        #     case.request_data['data']['header']['rotate__code'] = code
        #     case.request_data['data']['header']['warehouse__code'] = mid_res['id']
        #     case.request_data['data']['header']['putaway__name'] = name
        #     case.request_data['data']['header']['rotate__name'] = name
        #     case.request_data['data']['header']['rule_id'] = name
        #     case.request_data['data']['header']['warehouse_id'] = name
        #     case.request_data['data']['header']['rotate_rule_id'] = name
        #     case.request_data['data']['header']['warehouse__name'] = name


        elif case.name == 'pre_allocation_rule':
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__name'] = name
            case.request_data['selectedRows'][0]['header']['currentData']['code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['name'] = name + '预分配规则'
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse_id'] = mid_res['id']

        elif case.name == 'allocation_rule':
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__name'] = name
            case.request_data['selectedRows'][0]['header']['currentData']['code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['name'] = name + '分配规则'
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse_id'] = mid_res['id']
            case.request_data['selectedRows'][0]['header']['currentData']['preallocate__name'] = name + '预分配规则'
            case.request_data['selectedRows'][0]['header']['currentData']['preallocate_rule_id'] = mid_res['pre_allocation_id']
            case.request_data['selectedRows'][0]['header']['currentData']['preallocate__code'] = code

        elif case.name == 'cutbox_rule':
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__name'] = name
            case.request_data['selectedRows'][0]['header']['currentData']['code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['name'] = name + '切分规则'
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse_id'] = mid_res['id']

        elif case.name == 'wave_rule':
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__name'] = name
            case.request_data['selectedRows'][0]['header']['currentData']['code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['name'] = name + '波次规则'
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse_id'] = mid_res['id']

        elif case.name == 'pick_order_rule':
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__name'] = name
            case.request_data['selectedRows'][0]['header']['currentData']['code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['name'] = name + '拣选单规则'
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse_id'] = mid_res['id']

        elif case.name == 'out_validation_rule':
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__name'] = name
            case.request_data['selectedRows'][0]['header']['currentData']['code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['name'] = name + '拣选单规则'
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__code'] = code
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse_id'] = mid_res['id']

        loginfo.debug('\033[32m测试用例执行前的处理\033[0m')

    def after_parameter(self, case):
        loginfo.debug('\033[32m用例执行后数据处理 {}\033[0m'.format(case.actual))


if __name__ == '__main__':
    GQTest().run_test()
